// FastHash.dll
//
// C|[gCuł FastHashDll.lib gp΁ADLLƐÓIɃNł܂
// FastHash.dll݂ȂƓ삵ȂAvP[VɂȂĂ܂܂̂ŁA
// ÓIɃN̂͂ł邾
// FastHashDll.lib  Visual C++ .NET 2003 ō쐬Ă܂

#pragma once
#pragma comment(lib, "FastHashDll.lib")

// FastHashDll.h includeOɁAWindows.h includeĂ

#ifdef STRICT
DECLARE_HANDLE(HFH_HASH_ENGINE);
DECLARE_HANDLE(HFH_HASH_VALUE);

#else
typedef HANDLE HFH_HASH_ENGINE;
typedef HANDLE HFH_HASH_VALUE;

#endif


// nbV^Cv̒`
#define FH_HASHTYPE_CRC16          0x0001
#define FH_HASHTYPE_CRC32          0x0002
#define FH_HASHTYPE_MD5            0x0004
#define FH_HASHTYPE_SHA1           0x0008
#define FH_HASHTYPE_SHA256         0x0010
#define FH_HASHTYPE_SHA384         0x0020
#define FH_HASHTYPE_SHA512         0x0040
#define FH_HASHTYPE_RIPEMD128      0x0080
#define FH_HASHTYPE_RIPEMD160      0x0100
#define FH_HASHTYPE_RIPEMD256      0x0200
#define FH_HASHTYPE_RIPEMD320      0x0400


#ifdef __cplusplus
extern "C" {
#endif

HFH_HASH_ENGINE WINAPI FHCreateHashEngineObject(DWORD dwHashType);
HFH_HASH_VALUE WINAPI FHCreateHashValueObject(HFH_HASH_ENGINE hEngine);
BOOL WINAPI FHCloseObjectHandle(HANDLE hHandle);
BOOL WINAPI FHComputeHash(HFH_HASH_ENGINE hEngine, LPCVOID lpBuffer, DWORD dwNumberOfBytesToCompute);
BOOL WINAPI FHModifyHashType(HFH_HASH_ENGINE hEngine, DWORD dwRemove, DWORD dwAdd);
DWORD WINAPI FHGetHashType(HANDLE hHandle);
BOOL WINAPI FHInitHashValue(HFH_HASH_ENGINE hEngine);
DWORD WINAPI FHGetHashValue(HANDLE hHandle, LPVOID lpBuffer, DWORD dwHashType);
DWORD WINAPI FHGetAllHashTypeCount();
BOOL WINAPI FHEnumHashType(DWORD dwIndex, LPTSTR lpName, LPDWORD lpdwHashType, LPDWORD lpdwHashValueSize);
BOOL WINAPI FHGetHashTypeInfo(DWORD dwHashType, LPTSTR lpName, LPDWORD lpdwHashValueSize);
VOID WINAPI FHHashValueToHashString(LPTSTR lpString, LPCVOID lpValue, DWORD dwHashSize, BOOL bSmallString);
DWORD WINAPI FHHashStringToHashValue(LPVOID lpValue, LPCTSTR lpString, DWORD dwStringBytes);
BOOL WINAPI FHGetVersion(LPDWORD lpMajorVersion, LPDWORD lpMinorVersion);
BOOL WINAPI FHGetVersionString(LPTSTR lpBuffer);

#ifdef __cplusplus
}
#endif
